﻿// Type: Jounce.Core.ViewModel.BaseViewModel
// Assembly: Jounce, Version=1.0.4105.34826, Culture=neutral, PublicKeyToken=null
// Assembly location: C:\Users\r2\Documents\Presentations\Intro to Jounce\Code\TestArea\DynamicXap\DynamicXap\Jounce\Jounce.dll

using Jounce.Core.Application;
using Jounce.Core.Event;
using Jounce.Core.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Composition;

namespace Jounce.Core.ViewModel
{
    public abstract class BaseViewModel : BaseNotify, IViewModel, INotifyPropertyChanged
    {
        public List<string> RegisteredViews { get; }

        [Import]
        public IEventAggregator EventAggregator { get; set; }

        [Import]
        public IViewModelRouter Router { get; set; }

        [Import(AllowDefault = true, AllowRecomposition = true)]
        public ILogger Logger { get; set; }

        protected bool InDesigner { get; }

        #region IViewModel Members

        public bool GoToVisualStateForView(string view, string state, bool useTransitions);
        public void Initialize();
        public void Activate(string viewName);
        public void Activate(string viewName, IDictionary<string, object> parameters);
        public void Deactivate(string viewName);
        public Action<string, bool> GoToVisualState { get; set; }

        #endregion

        public void RegisterVisualState(string view, Action<string, bool> action);
        protected virtual void InitializeVm();
        protected virtual void ActivateView(string viewName, IDictionary<string, object> viewParameters);
        protected virtual void DeactivateView(string viewName);
        public override string ToString();
    }
}
