﻿using System.ComponentModel.Composition;
using System.Windows;
using Jounce.Core.Event;

namespace EvenSimplerNavigation
{
    public partial class App: IEventSink<UnhandledExceptionEvent>
    {
        [Import]
        public IEventAggregator EventAggregator { get; set; }

        public App()
        {
            this.Startup += this.Application_Startup;
            InitializeComponent();
        }

        private void Application_Startup(object sender, StartupEventArgs e)
        {
            CompositionInitializer.SatisfyImports(this);
            EventAggregator.SubscribeOnDispatcher(this);
        }

        public void HandleEvent(UnhandledExceptionEvent publishedEvent)
        {
            MessageBox.Show(publishedEvent.UncaughtException.ToString());
            publishedEvent.Handled = true;
        }
    }
}
