using System.ComponentModel.Composition;
using Jounce.Core.Command;
using Jounce.Core.ViewModel;
using Jounce.Framework;
using Jounce.Framework.Command;

namespace EvenSimplerNavigation.ViewModel
{
    [ExportAsViewModel("MainViewModel")]
    public class MainViewModel: BaseViewModel, IPartImportsSatisfiedNotification
    {
        public IActionCommand<string> NavigateCommand { get; private set; }

        private object _currentView;
        public object CurrentView
        {
            get { return _currentView; }
            set
            {
                _currentView = value;
                RaisePropertyChanged(() => CurrentView);
                NavigateCommand.RaiseCanExecuteChanged();
            }
        }

        #region IPartImportsSatisfiedNotification Members

        public void OnImportsSatisfied()
        {
            NavigateCommand = new ActionCommand<string>(
                            view =>
                            {
                                CurrentView = view;
                                EventAggregator.Publish(view.AsViewNavigationArgs());
                            },
                            view => true);
        }

        #endregion
    }
}