﻿// Type: Jounce.Framework.ViewModel.BaseEntityViewModel
// Assembly: Jounce, Version=1.0.4105.34826, Culture=neutral, PublicKeyToken=null
// Assembly location: C:\Users\r2\Documents\Presentations\Intro to Jounce\Code\IntroToJounce\Jounce.dll

using Jounce.Core.ViewModel;
using Jounce.Framework.Command;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq.Expressions;

namespace Jounce.Framework.ViewModel
{
    public abstract class BaseEntityViewModel : BaseViewModel, INotifyDataErrorInfo
    {
        public bool Committed { get; set; }
        public ActionCommand<object> CommitCommand { get; }
        protected bool HasErrors { get; }

        #region INotifyDataErrorInfo Members

        IEnumerable INotifyDataErrorInfo.GetErrors(string propertyName);
        bool INotifyDataErrorInfo.HasErrors { get; }
        event EventHandler<DataErrorsChangedEventArgs> INotifyDataErrorInfo.ErrorsChanged;

        #endregion

        protected virtual void ValidateAll();
        protected virtual void OnCommitted();
        protected virtual IEnumerable GetErrors(string propertyName);
        protected virtual void SetError(string propertyName, string error);
        protected virtual void SetError<T>(Expression<Func<T>> propertyExpresssion, string error);
        protected virtual void ClearErrors(string propertyName);
        protected virtual void ClearErrors<T>(Expression<Func<T>> propertyExpresssion);
        protected virtual void SetErrors<T>(Expression<Func<T>> propertyExpresssion, IEnumerable<string> propertyErrors);
        protected virtual void SetErrors(string propertyName, IEnumerable<string> propertyErrors);
        protected virtual void RaiseErrorsChanged(string propertyName);
        protected virtual void RaiseErrorsChanged<T>(Expression<Func<T>> propertyExpresssion);
    }
}
